DisplayOverviewHud = {};

DisplayOverviewHud.metadata = {
	interface = " FS19 1.x",
	title = " DisplayOverviewHud",
	notes = " Zeight eine Übersicht der Lagerbestände/Animals und Preise/Bestpreise",
	author = " (by HappyLooser)",
	version = " v0.2 Alpha",
	datum = " 20.11.2018",
	update = " 24.12.2018",
	web = " no",
	info = " Link Freigabe,Änderungen,Kopien oder Code Benutzung ist ohne meine Zustimmung nicht erlaubt",
	"##Orginal Link Freigabe:"
};

DisplayOverviewHud.modDir = g_currentModDirectory;
function DisplayOverviewHud:loadMap(name)
	g_currentMission.DisplayOverviewHud = DisplayOverviewHud;	
	print("---loading".. tostring(DisplayOverviewHud.metadata.title).. tostring(DisplayOverviewHud.metadata.version).. tostring(DisplayOverviewHud.metadata.author).. "---")
	if g_server ~= nil and g_client ~= nil and g_dedicatedServerInfo ~= nil then return;end;
	DisplayOverviewHud.isLoadMap = false;
	DisplayOverviewHud.settings = {isOn=true,isSmallView=false,isLoadOverlays=false,size=0.010,onlyAppearsOnStats=true};
	DisplayOverviewHud.settings.draw = {
		modus = 1,
		isFillStorage = true;
		lineFat = 0.0006, --not edit pls
		heightDistance = 0.0028, --not edit pls
		widthDif = 0.005, --not edit pls
		seeLine = false,
		lineWho = {fillTypes=true,amounts=true,stations=true}
	};
	DisplayOverviewHud.color = {		
		background = { 0, 0, 0, 0.50 }, --black
		backgroundFillTypes = { 0, 0, 0, 0.50 }, --black
		backgroundStations = { 0, 0, 0, 0.50 }, --black
		backgroundAmounts = { 0, 0, 0, 0.50 }, --black
		line = { 1, 1, 1, 0.80 }, --white
		lineFillTypes = { 1, 1, 1, 0.60 }, --white
		lineStations = { 1, 1, 1, 0.60 }, --white
		lineAmounts = { 1, 1, 1, 0.60 }, --white
		greatDemand = { 0/255, 255/255, 255/255, 1.00 }, --ls15
		bestPrice = { 0/255, 100/255,  0/255, 1.00 }, --darkGreen
		txtDefault = {1, 1, 1, 1}, --white
		txtIsAmount = {1, 1, 1, 1}, --white
		txtIsNotAmount = {1, 1, 1, 0.70} --white
	};	
	DisplayOverviewHud.settingsDir = getUserProfileAppPath().. "modsSettings/DisplayOverviewHud/";	
	DisplayOverviewHud.rebootXml = false;
	DisplayOverviewHud.hlDebugMode = false;
	source(DisplayOverviewHud.modDir.."XmlSettings.lua");
	DisplayOverviewHud.inGameDisplays = {};	
	DisplayOverviewHud:setGetCfg(true);	
	DisplayOverviewHud:init();
	DisplayOverviewHud.settings.isLoadOverlays = DisplayOverviewHud:loadOverlays();
end;

function DisplayOverviewHud:deleteMap()
	if g_server ~= nil and g_client ~= nil and g_dedicatedServerInfo ~= nil then return;end;
	DisplayOverviewHud:setGetCfg(false);DisplayOverviewHud:deleteOverlays();	
end;

function DisplayOverviewHud:mouseEvent(posX, posY, isDown, isUp, button)
end;

function DisplayOverviewHud:keyEvent(unicode, sym, modifier, isDown)
	if g_server ~= nil and g_client ~= nil and g_dedicatedServerInfo ~= nil then return;end;	
	if DisplayOverviewHud:get_hl("getIngameMap", {}, "getIngameMap") or DisplayOverviewHud:get_hl("getFullSize", {true, false}, "getFullSize") then return;end;
	if DisplayOverviewHud.rebootXml and DisplayOverviewHud:get_hl("getFullSize", {false, true}, "getFullSize") and Input.isKeyPressed(Input.KEY_esc) then
		DisplayOverviewHud:setGetCfg(true);	
	end;
	if Input.isKeyPressed(Input[g_inputBinding.nameActions["DisplayOverviewHud"].primaryKeyboardInput]) then
		if DisplayOverviewHud.settings.draw.modus == 2 then DisplayOverviewHud.settings.draw.modus = 1;return;end;
		if DisplayOverviewHud.settings.draw.modus == 1 then DisplayOverviewHud.settings.draw.modus = 2;return;end;
	end;
	if DisplayOverviewHud.hlDebugMode and not DisplayOverviewHud:get_hl("getFullSize", {true, true}, "getFullSize") and Input.isKeyPressed(Input.KEY_f2)then		
		if g_currentMission.hl.debug ~= nil then
			local a=1;		
			for key,value in pairs(g_currentMission.hl.debug) do
				for key1,value1 in pairs(value) do			
					print(tostring(a).. ".hl_Debug Error at ".. tostring(key).. " = ".. tostring(value1))			
					a=a+1;
				end;
			end;
		else
			print("1.hl_Debug NOT Found Error at ".. tostring(DisplayOverviewHud.metadata.title))
		end;	
		
		--if test then
			
		--end;
		
	end;
end;

function DisplayOverviewHud:update(dt)	
	if g_server ~= nil and g_client ~= nil and g_dedicatedServerInfo ~= nil then return;end;
	if not DisplayOverviewHud.isLoadMap then
		DisplayOverviewHud.isLoadMap = true;
		DisplayOverviewHud:loadFillTypes();
		DisplayOverviewHud:loadPlaceables();
		getInGameDisplays();
		local a=0;
		for key,value in pairs(DisplayOverviewHud.fillTypes) do
			a = a+1;
			--print(tostring(a).. " fillTypes ".. tostring(key).. " = ".. tostring(value))			
			if type(value) == "table" then	
				for key1,value1 in pairs(value) do
					--print(tostring(a).. " fillTypes under table ".. tostring(key1).. " = ".. tostring(value1))
				end;
			end;
		end;
	end;
end;

function DisplayOverviewHud:draw()
	if g_server ~= nil and g_client ~= nil and g_dedicatedServerInfo ~= nil then return;end;
	if g_currentMission.hl.getIngameMap() or g_currentMission.hl.getFullSize(true, true) then return;end;
	--respect settings for other mods
	setTextAlignment(0);
	setTextColor(1, 1, 1, 1);
	setTextBold(false);
	--respect settings for other mods
	if DisplayOverviewHud.settings.isOn then
		if DisplayOverviewHud.settings.isLoadOverlays then			
			setGreatDemand();			
			local drawFillTypeName = {};
			drawAmountFillType = {};
			DisplayOverviewHud:setGetStorages(ownerFarmId);
			local drawStationName = {};	
			
			local txtHeightFirst = 0;
			local fillTypeNameWidthTotal = 0;
			local fillTypeNameHeightTotal = 0;
			local fillTypeNameFirstPosX = 0;
			local stationNameWidthTotal = 0;
			local stationNameFirstPosX = 0;
			local amountFillTypeWidthTotal = 0;
			
			
			local widthDif = 0.005;
			--local widthMaxFruitName = 0;
			local minStationNameLength = 9;
			local maxStationNameLength = 20;
			local maxFruitNameLength = 20;
			local heightDistance = DisplayOverviewHud.settings.draw.heightDistance; --*DisplayOverviewHud.inGameDisplays.rightUpDisplay.moneyBox.overlay.scaleHeight;
			local lineDistance = heightDistance;
			local lineFat = DisplayOverviewHud.settings.draw.lineFat;
			local size = DisplayOverviewHud.settings.size;
			--drawFillTypeName[#drawFillTypeName+1] = {};
			
			--get fillTypes
			if DisplayOverviewHud.settings.draw.modus == 1 or 2 then
				for key,descFruit in pairs (DisplayOverviewHud.fillTypes) do
					local desc = g_fillTypeManager.fillTypes[key];
					if desc ~= nil and DisplayOverviewHud.fillTypes[desc.index] ~= nil then
				--for a=1, #DisplayOverviewHud.fillTypes do
					--if DisplayOverviewHud.fillTypes[a] ~= nil then
					--local desc = DisplayOverviewHud.fillTypes[a];
					--reset
					DisplayOverviewHud.fillTypes[desc.index].isDraw = false;
					DisplayOverviewHud.fillTypes[desc.index].drawPosY = nil;
					DisplayOverviewHud.fillTypes[desc.index].drawLinePosY = nil;
					DisplayOverviewHud.fillTypes[desc.index].bestPrice = 0;
					
					--reset
					local fruitName = tostring(DisplayOverviewHud.fillTypes[desc.index].fruitName);
					drawFillTypeName[#drawFillTypeName+1] = {};
					if string.len(fruitName) > maxFruitNameLength+2 then fruitName = getMaxNameLength(fruitName, maxFruitNameLength);end; -- +2 for ..
					drawFillTypeName[#drawFillTypeName].txt = fruitName;
					DisplayOverviewHud.fillTypes[desc.index].drawTxt = fruitName;
					local txtHeight,_ = getTextHeight(size, fruitName);
					--print("txtHeight Old...".. tonumber(txtHeight).. " -filltype: ".. tostring(fruitName));
					--print("txtHeight New...".. tonumber(txtHeight+heightDistance+(lineFat/2)).. " -filltype: ".. tostring(fruitName));
					
					DisplayOverviewHud.fillTypes[desc.index].drawTxtHeight = txtHeight+heightDistance+lineFat;
					DisplayOverviewHud.fillTypes[desc.index].drawTxtWidth = getTextWidth(size, fruitName)+widthDif;
					DisplayOverviewHud.fillTypes[desc.index].drawTxtColor = DisplayOverviewHud.color.txtDefault;
					if DisplayOverviewHud.greatDemandFillTypes ~= nil and DisplayOverviewHud.greatDemandFillTypes[desc.index] ~= nil then DisplayOverviewHud.fillTypes[desc.index].drawTxtColor = DisplayOverviewHud.color.greatDemand;end;
					
					
					
					drawFillTypeName[#drawFillTypeName].txtColor = DisplayOverviewHud.color.txtDefault;
					if DisplayOverviewHud.greatDemandFillTypes ~= nil and DisplayOverviewHud.greatDemandFillTypes[desc.index] ~= nil then drawFillTypeName[#drawFillTypeName].txtColor = DisplayOverviewHud.color.greatDemand;end;
					drawFillTypeName[#drawFillTypeName].txtHeight = txtHeight+heightDistance+lineFat;
					drawFillTypeName[#drawFillTypeName].txtWidth = getTextWidth(size, fruitName)+widthDif;
					drawFillTypeName[#drawFillTypeName].descIndex = desc.index;
					drawFillTypeName[#drawFillTypeName].totalAmount = 0;
					if fillTypeNameWidthTotal < drawFillTypeName[#drawFillTypeName].txtWidth then fillTypeNameWidthTotal = drawFillTypeName[#drawFillTypeName].txtWidth;end;
					if txtHeightFirst == 0 then txtHeightFirst = drawFillTypeName[#drawFillTypeName].txtHeight*2;end; --better distance for fillTypes and stationes (Money Box)
					--end;
					end;
				end;
			end;
			--get fillTypes
			
			--get stationes
			if DisplayOverviewHud.settings.draw.modus == 2 then
				for key,station in pairs(DisplayOverviewHud.sellStations) do
					if (station.appearsOnStats and DisplayOverviewHud.settings.onlyAppearsOnStats) or not DisplayOverviewHud.settings.onlyAppearsOnStats then
						local stationName = tostring(station.name);
						if string.len(stationName) < minStationNameLength then stationName = getMinNameLength(stationName, minStationNameLength);end;
						if string.len(stationName) > maxStationNameLength+2 then stationName = getMaxNameLength(stationName, maxStationNameLength);end; -- +2 for ..
						drawStationName[#drawStationName+1] = {};
						drawStationName[#drawStationName].txt = stationName;
						drawStationName[#drawStationName].txtColor = DisplayOverviewHud.color.txtDefault;
						if DisplayOverviewHud.greatDemand ~= nil and DisplayOverviewHud.greatDemand[station.name] ~= nil then drawStationName[#drawStationName].txtColor = DisplayOverviewHud.color.greatDemand;end;
						drawStationName[#drawStationName].txtHeight = getTextHeight(size, stationName)+heightDistance+lineFat;
						drawStationName[#drawStationName].txtWidth = getTextWidth(size, stationName)+widthDif;
						drawStationName[#drawStationName].descIndex = station.posOnTable;
						stationNameWidthTotal = stationNameWidthTotal+drawStationName[#drawStationName].txtWidth;
						local sellingStation = DisplayOverviewHud.sellStations[station.posOnTable].object.sellingStation;
						if sellingStation ~= nil then
							for fillType,isAccepted in pairs(sellingStation.acceptedFillTypes) do
								if isAccepted and DisplayOverviewHud.fillTypes[fillType] ~= nil then									
									local pricePerLiter = ((sellingStation.fillTypePrices[fillType]+sellingStation.fillTypePriceRandomDelta[fillType])*sellingStation.priceMultipliers[fillType]*EconomyManager.getPriceMultiplier())*1000;
									if pricePerLiter > 	DisplayOverviewHud.fillTypes[fillType].bestPrice then DisplayOverviewHud.fillTypes[fillType].bestPrice = pricePerLiter;end;														
								end;
							end;
						end;
					end;
				end;
			end;
			--get stationes
			
			--drawfillTypes					
			if DisplayOverviewHud.settings.draw.modus == 1 or 2 then
				if #drawFillTypeName > 0 then
					DisplayOverviewHud.overlays["groundFillTypes"]:render();
					local fillTypeNamePosX = 1.0-fillTypeNameWidthTotal;										
					local fillTypeNamePosY = getRightPosY()-txtHeightFirst;
					local fillTypeNameWidth = 0;
					fillTypeNameFirstPosX = fillTypeNamePosX;
					for a=1, #drawFillTypeName do						
						setTextColor(unpack(drawFillTypeName[a].txtColor));
						drawFillTypeName[a].drawLinePosY = (fillTypeNamePosY-drawFillTypeName[a].txtHeight)-heightDistance;
						fillTypeNamePosY = fillTypeNamePosY-drawFillTypeName[a].txtHeight;
						fillTypeNameHeightTotal = fillTypeNameHeightTotal+drawFillTypeName[a].txtHeight;
						if fillTypeNameWidth < drawFillTypeName[a].txtWidth then fillTypeNameWidth = drawFillTypeName[a].txtWidth;end;
						renderText(fillTypeNamePosX+(widthDif/2), fillTypeNamePosY, size, drawFillTypeName[a].txt);
						--drawFillTypeName[a].drawPosY = fillTypeNamePosY;
						--print("oldPosY...".. tonumber(fillTypeNamePosY).. " -filltype: ".. tostring(drawFillTypeName[a].txt));
						--print("newPosY...".. tonumber(fillTypeNamePosY-heightDistance).. " -filltype: ".. tostring(drawFillTypeName[a].txt));
						--drawFillTypeName[a].drawLinePosY = fillTypeNamePosY-(lineDistance);
						DisplayOverviewHud.fillTypes[drawFillTypeName[a].descIndex].drawPosY = fillTypeNamePosY;
						DisplayOverviewHud.fillTypes[drawFillTypeName[a].descIndex].drawLinePosY = math.min(fillTypeNamePosY,fillTypeNamePosY-(heightDistance/2)-(lineFat/2));
						DisplayOverviewHud.fillTypes[drawFillTypeName[a].descIndex].isDraw = true;
						if DisplayOverviewHud.settings.draw.seeLine and DisplayOverviewHud.settings.draw.lineWho.fillTypes then
							--DisplayOverviewHud:get_hl("setOverlay", {
							DisplayOverviewHud:setOverlay(self, DisplayOverviewHud.overlays["lineFillTypes"], DisplayOverviewHud.overlays["groundFillTypes"].x,drawFillTypeName[a].drawLinePosY,fillTypeNameWidthTotal,lineFat);
							--DisplayOverviewHud:setOverlay(
							DisplayOverviewHud.overlays["lineFillTypes"]:render();
						end;
					end;
					DisplayOverviewHud:get_hl("setOverlay", {DisplayOverviewHud.overlays["groundFillTypes"], fillTypeNamePosX,fillTypeNamePosY-(heightDistance/2)-(txtHeightFirst/2),fillTypeNameWidth+widthDif,fillTypeNameHeightTotal+(txtHeightFirst)}, "setOverlay Background FillType");
					--if DisplayOverviewHud.settings.draw.seeLine and DisplayOverviewHud.settings.draw.lineWho.fillTypes then
						DisplayOverviewHud:get_hl("setOverlay", {DisplayOverviewHud.overlays["lineFillTypes"], DisplayOverviewHud.overlays["groundFillTypes"].x,DisplayOverviewHud.overlays["groundFillTypes"].y,lineFat,DisplayOverviewHud.overlays["groundFillTypes"].height}, "setOverlay Background Line FillTypes vertical first");
						DisplayOverviewHud.overlays["lineFillTypes"]:render();
					--end;
				end;
			end;			
			--draw fillTypes
			
			--draw stationes
			if DisplayOverviewHud.settings.draw.modus == 2 then
				if #drawStationName > 0 then
					DisplayOverviewHud.overlays["groundStations"]:render();
					local stationNamePosX = 1.0-fillTypeNameWidthTotal-stationNameWidthTotal;
					local stationNamePosY = getRightPosY()-txtHeightFirst;
					local stationNameHeight = 0;
					local stationNameWidth = 0;
					stationNameFirstPosX = stationNamePosX;
					for a=1, #drawStationName do
						setTextColor(unpack(drawStationName[a].txtColor));
						renderText(stationNamePosX+(widthDif/2)+stationNameWidth, stationNamePosY, size, drawStationName[a].txt);						
						drawStationName[a].drawPosX = stationNamePosX+(widthDif/2)+stationNameWidth;
						local sellingStation = DisplayOverviewHud.sellStations[drawStationName[a].descIndex].object.sellingStation;
						if sellingStation ~= nil then
							for fillType,isAccepted in pairs(sellingStation.acceptedFillTypes) do
								if isAccepted and DisplayOverviewHud.fillTypes[fillType] ~= nil and DisplayOverviewHud.fillTypes[fillType].isDraw then
									setTextColor(unpack(drawStationName[a].txtColor));									
									local difficultyMultiplier = math.max(2 * (3 - g_currentMission.missionInfo.difficulty), 1);
									local pricePerLiter = ((sellingStation.fillTypePrices[fillType]+sellingStation.fillTypePriceRandomDelta[fillType])*sellingStation.priceMultipliers[fillType]*EconomyManager.getPriceMultiplier())*1000;
									if pricePerLiter >= DisplayOverviewHud.fillTypes[fillType].bestPrice then setTextColor(unpack(DisplayOverviewHud.color.bestPrice));end;
									local fillTypePrice = g_i18n:formatMoney(pricePerLiter);
									if DisplayOverviewHud.greatDemandFillTypes ~= nil and DisplayOverviewHud.greatDemandFillTypes[fillType] ~= nil and DisplayOverviewHud.greatDemandFillTypes[fillType].stationName == drawStationName[a].txt then
										setTextColor(unpack(DisplayOverviewHud.color.greatDemand));
									end;									
									setTextAlignment(1);
									renderText(stationNamePosX+(widthDif/2)+(stationNameWidth)+(drawStationName[a].txtWidth/2), DisplayOverviewHud.fillTypes[fillType].drawPosY, size, tostring(fillTypePrice));
									setTextAlignment(0);
									--local priceDynamics = sellingStation:getCurrentPricingTrend(fillType)
									--local dynamics = "";
									--if priceDynamics == 2 then dynamics = "^";setTextColor(0/255, 255/255,   0/255, 1)end;									
									--renderText(stationNamePosX+(widthDif/2)+(stationNameWidth), DisplayOverviewHud.fillTypes[fillType].drawPosY, size, tostring(dynamics));
								end;
							end;
						end;
						if DisplayOverviewHud.settings.draw.seeLine and DisplayOverviewHud.settings.draw.lineWho.stations then
							--DisplayOverviewHud:get_hl("setOverlay", {DisplayOverviewHud.overlays["lineStations"], DisplayOverviewHud.overlays["groundStations"].x+stationNameWidth,DisplayOverviewHud.overlays["groundStations"].y,lineFat,DisplayOverviewHud.overlays["groundStations"].height}, "setOverlay Background Line Stations vertical");
							--DisplayOverviewHud.overlays["lineStations"]:render();
						end;
						stationNameWidth = stationNameWidth+drawStationName[a].txtWidth;
					end;																														---(heightDistance/2)
					DisplayOverviewHud:get_hl("setOverlay", {DisplayOverviewHud.overlays["groundStations"], stationNamePosX,stationNamePosY-(heightDistance/2)-(txtHeightFirst/2)-fillTypeNameHeightTotal,stationNameWidth,fillTypeNameHeightTotal+(txtHeightFirst)}, "setOverlay Background Stations");
					--if DisplayOverviewHud.settings.draw.seeLine and DisplayOverviewHud.settings.draw.lineWho.stations then					---(heightDistance)
						DisplayOverviewHud:get_hl("setOverlay", {DisplayOverviewHud.overlays["lineStations"], DisplayOverviewHud.overlays["groundStations"].x,stationNamePosY,DisplayOverviewHud.overlays["groundStations"].width,lineFat}, "setOverlay Background Line Stations horizontal first StationName");
						DisplayOverviewHud.overlays["lineStations"]:render();
						--for key,desc in pairs(DisplayOverviewHud.fillTypes) do
						--	if DisplayOverviewHud.fillTypes[desc.descIndex].isDraw and DisplayOverviewHud.fillTypes[desc.descIndex].drawPosY ~= nil then																		---(heightDistance)
						--		DisplayOverviewHud:get_hl("setOverlay", {DisplayOverviewHud.overlays["lineStations"], DisplayOverviewHud.overlays["groundStations"].x,DisplayOverviewHud.fillTypes[desc.descIndex].drawPosY,DisplayOverviewHud.overlays["groundStations"].width,lineFat}, "setOverlay Background Line Stations/FillTypes horizontal");
						--		DisplayOverviewHud.overlays["lineStations"]:render();
						--	end;
						--end;						
						DisplayOverviewHud:get_hl("setOverlay", {DisplayOverviewHud.overlays["lineStations"], DisplayOverviewHud.overlays["groundStations"].x+DisplayOverviewHud.overlays["groundStations"].width,DisplayOverviewHud.overlays["groundStations"].y,lineFat,DisplayOverviewHud.overlays["groundStations"].height}, "setOverlay Background Line Stations vertical end");
						DisplayOverviewHud.overlays["lineStations"]:render();
						DisplayOverviewHud:get_hl("setOverlay", {DisplayOverviewHud.overlays["lineStations"], DisplayOverviewHud.overlays["groundStations"].x,DisplayOverviewHud.overlays["groundStations"].y,lineFat,DisplayOverviewHud.overlays["groundStations"].height}, "setOverlay Background Line Stations vertical first");
						DisplayOverviewHud.overlays["lineStations"]:render();
					--end;
				end;			
			end;
			--draw stationes
			--draw amounts
				if DisplayOverviewHud.settings.draw.modus == 1 or 2 then
					if #drawAmountFillType > 0 then
						if DisplayOverviewHud.settings.draw.modus == 1 then stationNameWidthTotal = 0;end;
						DisplayOverviewHud.overlays["groundAmounts"]:render();
						local amountWidth = getTextWidth(size, "999999999")+widthDif;
						local amountPosX = 1.0-fillTypeNameWidthTotal-stationNameWidthTotal-amountWidth;
						local amountPosY = getRightPosY()-txtHeightFirst;
						local amountHeight = 0;						
						DisplayOverviewHud:get_hl("setOverlay", {DisplayOverviewHud.overlays["groundAmounts"], amountPosX,DisplayOverviewHud.overlays["groundFillTypes"].y,amountWidth,DisplayOverviewHud.overlays["groundFillTypes"].height}, "setOverlay Background Stations");
						setTextColor(unpack(DisplayOverviewHud.color.txtIsAmount));
						for fillType,fillLevel in pairs(drawAmountFillType) do
							local isAmount = Utils.getNoNil(fillLevel.amount, 0)
							if isAmount > 0 then
								local amount = string.format("%1.0f", "".. isAmount);
								setTextAlignment(2);
								renderText(amountPosX+amountWidth-(widthDif/2), DisplayOverviewHud.fillTypes[fillType].drawPosY, size, tostring(amount));
								setTextAlignment(0);
							end;
						end;
						
					end;
				end;
			--draw amounts
		end;
	end;	
	--respect settings for other mods
	setTextAlignment(0);
	setTextColor(1, 1, 1, 1);
	setTextBold(false);
	--respect settings for other mods
end;

function DisplayOverviewHud:init()
	source(DisplayOverviewHud.modDir.."_hl.lua");
end;
addModEventListener(DisplayOverviewHud);

function DisplayOverviewHud:setOverlay(self, overlay, posX, posY, width, height)
	if overlay.overlayId then
		if width ~= nil then overlay.width = width;end;
		if height ~= nil then overlay.height = height;end;
		if posX ~= nil then overlay.x = posX;end;
		if posY ~= nil then overlay.y = posY;end;		
		--overlay:setPosition(posX, posY);
	end;
end;

function DisplayOverviewHud:deleteOverlays()
	if DisplayOverviewHud.overlays ~= nil then		
		for _index,v in pairs (DisplayOverviewHud.overlays) do
			local overlay = DisplayOverviewHud.overlays[_index];
			if overlay ~= nil and overlay and overlay.overlayId ~= nil and overlay.overlayId then
				overlay:delete();
				overlay = nil;
			end;
		end;
	end;
end;

function getMinNameLength(name, minLen)
	local newName = name;
	local i = 0;
	local first = false;
	while minLen > string.len(newName) do
		i = i + 1;
		if first then newName = " ".. newName;first = false;
		else newName = newName.. " ";first = true;end;
	end
	return newName;
end;

function getMaxNameLength(name, maxLen)				
	return string.sub(name, 0, maxLen).. "..";
end;

function getRightPosY()				
	local side = g_currentMission.hud.sideNotifications.overlay.y;
	local top = g_currentMission.hud.topNotification.overlay.y;
	if top > 1.0 and side > 1.0 then return DisplayOverviewHud.inGameDisplays.rightUpDisplay.moneyBox.overlay.y;end;
	return math.min(side, top);
end;

function getInGameDisplays()
	for key, value in pairs(g_currentMission.hud.displayComponents) do
		if g_currentMission.hud.displayComponents[key].showTime ~= nil then			
			DisplayOverviewHud.inGameDisplays.rightUpDisplay = g_currentMission.hud.displayComponents[key];
			break;
		end;
	end;	
end;

function setGreatDemand()				
	DisplayOverviewHud.greatDemand = nil;	
	DisplayOverviewHud.greatDemandFillTypes = nil;	
	local demandSales = g_currentMission.economyManager;
	if demandSales ~= nil and demandSales.numberOfConcurrentDemands ~= nil and demandSales.numberOfConcurrentDemands > 0 then
		for a=1, demandSales.numberOfConcurrentDemands do
			if demandSales.greatDemands ~= nil and demandSales.greatDemands[a].isRunning and demandSales.greatDemands[a].isValid then
				if demandSales.greatDemands[a].sellStation.stationName ~= nil then
					local stationName = demandSales.greatDemands[a].sellStation.stationName;
					--print("Große Nachfrage bei ".. tostring(stationName))
					--print("Große Nachfrage Fruit ".. tonumber(demandSales.greatDemands[a].fillTypeIndex))
					if DisplayOverviewHud.greatDemand == nil then DisplayOverviewHud.greatDemand = {};end;
					DisplayOverviewHud.greatDemand[stationName] = {};
					DisplayOverviewHud.greatDemand[stationName].fillType = demandSales.greatDemands[a].fillTypeIndex;
					DisplayOverviewHud.greatDemand[stationName].multiplier = demandSales.greatDemands[a].demandMultiplier;
					DisplayOverviewHud.greatDemand[stationName].demandDuration = demandSales.greatDemands[a].demandDuration;
					if DisplayOverviewHud.greatDemandFillTypes == nil then DisplayOverviewHud.greatDemandFillTypes = {};end;
					DisplayOverviewHud.greatDemandFillTypes[demandSales.greatDemands[a].fillTypeIndex] = {};
					DisplayOverviewHud.greatDemandFillTypes[demandSales.greatDemands[a].fillTypeIndex].multiplier = demandSales.greatDemands[a].demandMultiplier;
					DisplayOverviewHud.greatDemandFillTypes[demandSales.greatDemands[a].fillTypeIndex].stationName = stationName;
				end;
			end;
		end;
	end;
end;

function DisplayOverviewHud:get_hl(args, argsTable, errorTxtCall) --args hl table, argsTable a table with all args Values, errorTxt a Value for debug print
	local isOkay, result, argsError, errorTxt = nil,nil,nil,errorTxtCall;
	if DisplayOverviewHud.hlDebugMode and (errorTxtCall == nil or type(errorTxtCall) ~= "string" or string.len(errorTxtCall) == 0) then errorTxt = "Unknown";end;
	local foundArgsError = false;
	if type(argsTable) == "table" and g_currentMission.hl[args] ~= nil then	
		isOkay, result = pcall(g_currentMission.hl[args], unpack(argsTable));
	else
		foundArgsError = true;
	end;
	if DisplayOverviewHud.hlDebugMode and foundArgsError then isOkay=false;argsError="Unknown args or argsTable or argsTable = 0";end;		
	if DisplayOverviewHud.hlDebugMode and (not isOkay or foundArgsError) then DisplayOverviewHud:setDebug("MultiOverlayLightHudMod", args or "Unknown", errorTxt, argsError or "No args error", result or "NO result error");end;
	return result, isOkay;	
end;

function DisplayOverviewHud:setDebug(argsMod, args1, errorTxt, args2, args3)	
	if g_currentMission.hl.debug == nil then g_currentMission.hl.debug = {};end;
	if g_currentMission.hl.debug[argsMod] == nil then g_currentMission.hl.debug[argsMod] = {};end;
	local errorString = "Trigger: ".. tostring(args1).. " -errorTxtCall: ".. tostring(errorTxt).. " -argsError: ".. tostring(args2).. " -resultError: ".. tostring(args3);
	local alreadyExists = false;
	if #g_currentMission.hl.debug[argsMod] == 0 then table.insert(g_currentMission.hl.debug[argsMod], tostring(errorString));else
		for key,value in pairs(g_currentMission.hl.debug[argsMod]) do			
			if tostring(value) == errorString and string.len(value) == string.len(errorString) then alreadyExists=true;break;end;			
		end;		
		if not alreadyExists then table.insert(g_currentMission.hl.debug[argsMod], tostring(errorString));end;
	end;	
end;

function DisplayOverviewHud:loadOverlays()
	DisplayOverviewHud.overlays = {};
	local _,isOkay1 = DisplayOverviewHud:get_hl("getSetDefaultBackground", {DisplayOverviewHud.overlays, "groundFillTypes"}, "getSetDefaultBackground FillTypes");
	local _,isOkay2 = DisplayOverviewHud:get_hl("getSetDefaultBackground", {DisplayOverviewHud.overlays, "groundStations"}, "getSetDefaultBackground Stations");	
	local _,isOkay3 = DisplayOverviewHud:get_hl("getSetDefaultBackground", {DisplayOverviewHud.overlays, "groundAmounts"}, "getSetDefaultBackground Amounts");	
	local _,isOkay4 = DisplayOverviewHud:get_hl("getSetDefaultBackground", {DisplayOverviewHud.overlays, "lineFillTypes"}, "getSetDefaultBackground Line FillTypes");
	local _,isOkay5 = DisplayOverviewHud:get_hl("getSetDefaultBackground", {DisplayOverviewHud.overlays, "lineStations"}, "getSetDefaultBackground Line Stations");
	local _,isOkay6 = DisplayOverviewHud:get_hl("getSetDefaultBackground", {DisplayOverviewHud.overlays, "lineAmounts"}, "getSetDefaultBackground Line Amounts");
	local isOkay7 = DisplayOverviewHud:loadResetOverlayColor()
	return isOkay1 and isOkay2 and isOkay3 and isOkay4 and isOkay5 and isOkay6 and isOkay7;
end;

function DisplayOverviewHud:loadResetOverlayColor()
	local _,isOkay1 = DisplayOverviewHud:get_hl("setBackgroundColor", {DisplayOverviewHud.overlays["lineStations"], DisplayOverviewHud.color.lineStations}, "setBackgroundLineColor Line Stations");
	local _,isOkay2 = DisplayOverviewHud:get_hl("setBackgroundColor", {DisplayOverviewHud.overlays["groundFillTypes"], DisplayOverviewHud.color.backgroundFillTypes}, "setBackgroundColor FillTypes");
	local _,isOkay3 = DisplayOverviewHud:get_hl("setBackgroundColor", {DisplayOverviewHud.overlays["groundAmounts"], DisplayOverviewHud.color.backgroundAmounts}, "setBackgroundColor Amounts");
	local _,isOkay4 = DisplayOverviewHud:get_hl("setBackgroundColor", {DisplayOverviewHud.overlays["groundStations"], DisplayOverviewHud.color.backgroundStations}, "setBackgroundColor Stations");
	local _,isOkay5 = DisplayOverviewHud:get_hl("setBackgroundColor", {DisplayOverviewHud.overlays["lineFillTypes"], DisplayOverviewHud.color.lineFillTypes}, "setBackgroundLineColor Line FillTypes");
	local _,isOkay6 = DisplayOverviewHud:get_hl("setBackgroundColor", {DisplayOverviewHud.overlays["lineAmounts"], DisplayOverviewHud.color.lineAmounts}, "setBackgroundLineColor Line Amounts");
	return isOkay1 and isOkay2 and isOkay3 and isOkay4 and isOkay5 and isOkay6;
end;

function DisplayOverviewHud:loadFillTypes()
	DisplayOverviewHud.fillTypes = {};	
	local notFillTypes = {"horse_type", "cow_type", "sheep_type", "chicken_type", "pig_type", "unknown", "air", "def", "tarp", "treesaplings", "diesel", "fuel", "poplar", "weed"};
	local notFillNames = {"grass_windrow", "drygrass"};
	function isFill(descName)
		for _,notFill in pairs(notFillTypes) do			
			if string.find(descName, "grass") and isFillNames(descName) then return false;end;
			if string.find(descName, notFill) then return false;end;
		end;
		return true;
	end;
	function isFillNames(descName)
		local foundExactName = false;
		for _,notFill in pairs(notFillNames) do			
			if string.len(descName) == string.len(notFill) then foundExactName = true;end;
		end;
		return foundExactName;
	end;
	for _,desc in pairs(g_currentMission.fillTypeManager.fillTypes) do		
		if desc ~= nil and desc.name ~= nil then
			local descName = tostring(string.lower(desc.name));						
			if isFill(descName) then
				DisplayOverviewHud.fillTypes[desc.index] = {};
				DisplayOverviewHud.fillTypes[desc.index].fruitName = desc.title;				
				DisplayOverviewHud.fillTypes[desc.index].descName = desc.name;				
				DisplayOverviewHud.fillTypes[desc.index].descIndex = desc.index;
				DisplayOverviewHud.fillTypes[desc.index].bestPrice = 0;
				DisplayOverviewHud.fillTypes[desc.index].bestPriceStation = "";
				--DisplayOverviewHud.fillTypes[desc.index].greatDemandStation = nil;
				--DisplayOverviewHud.fillTypes[desc.index].greatDemandMultiplier = 1;
				DisplayOverviewHud.fillTypes[desc.index].showOnPriceTable = desc.showOnPriceTable;
				DisplayOverviewHud.fillTypes[desc.index].pricePerLiter = Utils.getNoNil(desc.pricePerLiter, 0);
				DisplayOverviewHud.fillTypes[desc.index].previousHourPrice = Utils.getNoNil(desc.previousHourPrice, 0);				
				DisplayOverviewHud.fillTypes[desc.index].massPerLiter = Utils.getNoNil(desc.massPerLiter, 0);
				DisplayOverviewHud.fillTypes[desc.index].startPricePerLiter = Utils.getNoNil(desc.startPricePerLiter, 0);
				DisplayOverviewHud.fillTypes[desc.index].totalAmount = Utils.getNoNil(desc.totalAmount, 0);
				DisplayOverviewHud.fillTypes[desc.index].amount = 0;
			end;
		end;
	end;
end;

function DisplayOverviewHud:loadPlaceables()
	DisplayOverviewHud.sellStations = {};
	DisplayOverviewHud.otherStations = {}; --later
	DisplayOverviewHud.buyingStations = {}; --later
	DisplayOverviewHud.storages = {}; --check extension storage later
	DisplayOverviewHud.animalsStable = {}; --later
	DisplayOverviewHud.bgas = {}; --later
	DisplayOverviewHud.otherObjects = {};
	for a=1, #g_currentMission.placeables do
		if g_currentMission.placeables[a] ~= nil then
			local object = g_currentMission.placeables[a];
			if object ~= nil and object.nodeId ~= nil then
				if object.sellingStation ~= nil and type(object.sellingStation) == "table" and object.sellingStation.incomeName ~= nil then					
					if string.find(object.sellingStation.incomeName, "harvestIncome") then						
						DisplayOverviewHud.sellStations[#DisplayOverviewHud.sellStations+1] = {};
						DisplayOverviewHud.sellStations[#DisplayOverviewHud.sellStations].object = object;
						DisplayOverviewHud.sellStations[#DisplayOverviewHud.sellStations].posOnTable = #DisplayOverviewHud.sellStations;
						DisplayOverviewHud.sellStations[#DisplayOverviewHud.sellStations].nodeId = object.nodeId;
						DisplayOverviewHud.sellStations[#DisplayOverviewHud.sellStations].name = Utils.getNoNil(object.sellingStation.stationName, "Unknown");
						DisplayOverviewHud.sellStations[#DisplayOverviewHud.sellStations].appearsOnStats = Utils.getNoNil(object.sellingStation.appearsOnStats, false);						
					end;
				elseif object.buyingStation ~= nil and type(object.buyingStation) == "table" and object.buyingStation.incomeName ~= nil then
					DisplayOverviewHud.buyingStations[#DisplayOverviewHud.buyingStations+1] = {};
					DisplayOverviewHud.buyingStations[#DisplayOverviewHud.buyingStations].posOnTable = #DisplayOverviewHud.buyingStations;
					DisplayOverviewHud.buyingStations[#DisplayOverviewHud.buyingStations].nodeId = object.nodeId;
					DisplayOverviewHud.buyingStations[#DisplayOverviewHud.buyingStations].object = object;
					DisplayOverviewHud.buyingStations[#DisplayOverviewHud.buyingStations].name = Utils.getNoNil(object.buyingStation.stationName, "Unknown");					
				elseif object.storages ~= nil and type(object.storages) == "table" and object.loadingStation ~= nil and object.loadingStation.stationName ~= nil then
					DisplayOverviewHud.storages[#DisplayOverviewHud.storages+1] = {};
					DisplayOverviewHud.storages[#DisplayOverviewHud.storages].posOnTable = #DisplayOverviewHud.storages;
					DisplayOverviewHud.storages[#DisplayOverviewHud.storages].nodeId = object.nodeId;
					DisplayOverviewHud.storages[#DisplayOverviewHud.storages].object = object;
					DisplayOverviewHud.storages[#DisplayOverviewHud.storages].name = Utils.getNoNil(object.loadingStation.stationName, "Unknown");
				elseif object.husbandryDirtyFlag ~= nil then
					DisplayOverviewHud.animalsStable[#DisplayOverviewHud.animalsStable+1] = {};
					DisplayOverviewHud.animalsStable[#DisplayOverviewHud.animalsStable].posOnTable = #DisplayOverviewHud.animalsStable;
					DisplayOverviewHud.animalsStable[#DisplayOverviewHud.animalsStable].nodeId = object.nodeId;
					DisplayOverviewHud.animalsStable[#DisplayOverviewHud.animalsStable].object = object;
					--DisplayOverviewHud.animalsStable[#DisplayOverviewHud.animalsStable].name = Utils.getNoNil(object.stationName, "Unknown");					
				elseif object.bunkerSilos ~= nil and object.bga ~= nil then
					DisplayOverviewHud.bgas[#DisplayOverviewHud.bgas+1] = {};
					DisplayOverviewHud.bgas[#DisplayOverviewHud.bgas].posOnTable = #DisplayOverviewHud.bgas;
					DisplayOverviewHud.bgas[#DisplayOverviewHud.bgas].nodeId = object.nodeId;
					DisplayOverviewHud.bgas[#DisplayOverviewHud.bgas].object = object;
				elseif object.stationName ~= nil then							
					DisplayOverviewHud.otherStations[#DisplayOverviewHud.otherStations+1] = {};
					DisplayOverviewHud.otherStations[#DisplayOverviewHud.otherStations].posOnTable = #DisplayOverviewHud.otherStations;
					DisplayOverviewHud.otherStations[#DisplayOverviewHud.otherStations].nodeId = object.nodeId;
					DisplayOverviewHud.otherStations[#DisplayOverviewHud.otherStations].object = object;
					DisplayOverviewHud.otherStations[#DisplayOverviewHud.otherStations].name = Utils.getNoNil(object.stationName, "Unknown");
				else
					DisplayOverviewHud.otherObjects[#DisplayOverviewHud.otherObjects+1] = {};
					DisplayOverviewHud.otherObjects[#DisplayOverviewHud.otherObjects].posOnTable = #DisplayOverviewHud.otherObjects;
					DisplayOverviewHud.otherObjects[#DisplayOverviewHud.otherObjects].nodeId = object.nodeId;
					DisplayOverviewHud.otherObjects[#DisplayOverviewHud.otherObjects].object = object;
				end;
			end;
		end;
	end;
end;

function DisplayOverviewHud:setGetStorages(ownerFarmId)	
	for key,storage in pairs(DisplayOverviewHud.storages) do
		local storageObject = storage.object.storages[1];		
		if storageObject ~= nil then --and storage.object.ownerFarmId == g_currentMission.player.farmId then			
			for fillType,isAccepted in pairs(storageObject.fillTypes) do
				if isAccepted and DisplayOverviewHud.fillTypes[fillType] ~= nil then
					DisplayOverviewHud.fillTypes[fillType].amount = Utils.getNoNil(storageObject.fillLevels[fillType]);
					if drawAmountFillType[fillType] == nil then drawAmountFillType[fillType] = {amount=0};end;
					drawAmountFillType[fillType].amount = drawAmountFillType[fillType].amount+Utils.getNoNil(storageObject.fillLevels[fillType], 0);
				end;
			end;
		end;
	end;
end;